routes/web.php
<?php

use App\Http\Controllers\Auth\AuthController;
use App\Http\Controllers\Dashboard\DashboardController;
use App\Http\Controllers\lab\LabController;
use App\Http\Controllers\lab\PasienController as LabPasienController;
use App\Http\Controllers\lab\ResultLabController;
use App\Models\Pasien;
use App\Http\Controllers\rawatjalan\KunjunganController;
use App\Http\Controllers\Pasien\PasienController;
use App\Http\Controllers\RekamMedis\EntryKunjunganController;
use App\Http\Controllers\RekamMedis\RiwayatKunjunganController;
use App\Http\Controllers\RekamMedis\RiwayatMedisController;
use App\Http\Controllers\Pembayaran\PembayaranController;
use App\Http\Controllers\Pharmacy\PharmacyController;
use Illuminate\Support\Facades\Route;

Route::controller(AuthController::class)->group(function () {
    Route::get('/', 'index')->name('login');
    Route::post('/', 'login')->name('loginPost');
    Route::get('/logout', 'logout')->name('logout');
});

Route::middleware('authenticated')->group(function () {
    // Dashboard Route
    Route::middleware('auth-roles:staff,dokter,admin,teknisi,perawat')->group(function () {
        // Pharmacy Route
        Route::prefix('pharmacy')->name('pharmacy.')->group(function () {
            Route::controller(PharmacyController::class)->group(function () {
                // prescription area
                Route::get('/receipt/{id}', 'getPrescriptionView')->name('prescriptionView');
                Route::get('/receipt/{visitId}/detail/{id}', 'getPrescriptionDetailView')->name('prescriptionDetail');
                Route::post('/receipt/detail', 'createDrugInPrescription')->name('createDrugInPrescription');
                Route::post('/receipt//detail/destroy/{id}', 'destroyDrugInPrescription')->name('destroyDrugInPrescription');
                Route::post('/receipt/detail/update/', 'updateDrugInPrescription')->name('updateDrugInPrescription');
                Route::get('/receipt/checkout/{id}/{visitId}', 'checkoutPrescription')->name('checkoutPrescription');

                // drug area
                Route::get('/medicine', 'listMedicine')->name('listMedicine');
                Route::get('/medicine/{id}', 'detailMedicine')->name('detailMedicine');
                Route::post('/medicine/{id}/destroy', 'destroyDrug')->name('destroyMedicine');
                Route::post('/medicine', 'createDrug')->name('createMedicine');
                Route::post('/medicine/{id}', 'updateDrug')->name('updateMedicine');
                Route::post('/medicine/{id}/update', 'updateDrugStock')->name('updateMedicineStock');
                Route::get('/medicine/export', 'downloadDrugExcel')->name('downloadDrugExcel');
            });
        });


        // Dashboard
        Route::controller(DashboardController::class)->group(function () {
            Route::get('/dashboard', 'index')->name('dashboard');
        });

        // START RJ
        // get data all detail kunjungan RJ
        Route::get('/rawat-jalan/detail-kunjungan', [KunjunganController::class, 'index'])->name('rawatjalan.index');

        // get data pemeriksaan lab and apotek
        Route::get('/rawat-jalan/set-data-pemeriksaan', [KunjunganController::class, 'pemeriksaan'])->name('rawatjalan.pemeriksaan');

        // get url add diagnosa
        Route::get('/rawat-jalan/{detailkunjungan}/add-diagnosa', [KunjunganController::class, 'adddiagnosa'])->name('rawatjalan.adddiagnosa');

        // patch data diagnosa
        Route::patch('/rawat-jalan/{detailkunjungan}/add-diagnosa/success-added', [KunjunganController::class, 'adddiagnosaAdded'])->name('rawatjalan.adddiagnosaAdded');

        // get url add data's (dokter,room,poli)
        Route::get('/rawat-jalan/detail-kunjungan/{detailkunjungan}/add-data-result', [KunjunganController::class, 'show'])->name('rawatjalan.show');

        // patch data results
        Route::patch('/rawat-jalan/detail-kunjungan/{detailkunjungan}/added-data-result', [KunjunganController::class, 'store'])->name('rawatjalan.store');

        // get sorting belum pemeriksaan
        Route::get('/rawat-jalan/detail-kunjungan/belum-pemeriksaan', [KunjunganController::class, 'sortingBelumPemeriksaan'])->name('rawatjalan.belumPemeriksaan');

        // get sorting sudah pemeriksaan
        Route::get('/rawat-jalan/detail-kunjungan/sudah-pemeriksaan', [KunjunganController::class, 'sortingSudahPemeriksaan'])->name('rawatjalan.sudahPemeriksaan');

        // get edit data page n fetch data 
        Route::get('/rawat-jalan/update-kunjungan/{detailkunjungan}/edit-datas', [KunjunganController::class, 'edit'])->name('rawatjalan.edit');

        // Update data
        Route::patch('/rawat-jalan/update-kunjungan/{detailkunjungan}/update-datas', [KunjunganController::class, 'update'])->name('rawatjalan.update');

        // delete data kunjungan 
        Route::delete('rawat-jalan/deleted/{detailkunjungan}/datas', [KunjunganController::class, 'destroy'])->name('rawatjalan.destroy');
    });

    Route::controller(PasienController::class)
        ->prefix('pasien')
        ->name('pasien.')
        ->group(function () {
            Route::get('/', 'index')->name('index');
            Route::get('/create', 'create')->name('create');
            Route::post('/store', 'store')->name('store');
            Route::get('/edit/{id}', 'edit')->name('edit');
            Route::post('/update/{id}', 'update')->name('update');
            Route::delete('/delete/{id}', 'delete')->name('delete');
        });

    // example when group route with the role
    Route::middleware('auth-roles:admin')->group(function () {
        Route::get('/onlyadmin', function () {
            return 'Only Admin';
        });
        Route::get('/lab', [LabController::class, 'index'])->name('lab.index');
        Route::get('/lab/create', [LabController::class, 'create'])->name('lab.create');
        Route::get('/lab/edit/{lab}', [LabController::class, 'edit'])->name('lab.edit');
        Route::put('/lab/edit/{lab}', [LabController::class, 'update'])->name('lab.update');
        Route::delete('/lab/{lab}', [LabController::class, 'destroy'])->name('lab.destroy');
        Route::post('/lab', [LabController::class, 'store'])->name('lab.store');

        Route::controller(ResultLabController::class)->group(function () {
            Route::get('/result-lab', 'index')->name('resultLab.index');
            Route::get('/result-lab/create', 'create')->name('resultLab.create');
            Route::post('/result-lab', 'store')->name('resultLab.store');
            Route::get('/result-lab/{resultLab}', 'show')->name('resultLab.show');
            Route::delete('/result-lab/{resultLab}', 'destroy')->name('resultLab.destroy');
            Route::get('/result-lab/edit/{resultLab}', 'edit')->name('resultLab.edit');
            Route::put('/result-lab/{resultLab}', 'update')->name('resultLab.update');
            Route::get('/result-lab/download/{resultLab}', 'download')->name('resultLab.download');
        });
    });

    Route::prefix('/pembayaran')->name('pembayaran')->group(function () {
        Route::get('/', [PembayaranController::class, 'index']);

        Route::prefix('/transaksi')->name('-transaksi')->group(function () {
            Route::get('/', [PembayaranController::class, 'transaksi']);
            Route::get('/{page?}', [PembayaranController::class, 'transaksi'])->name('-pagination');
            Route::post('/confirmation/{id?}', [PembayaranController::class, 'update'])->name('-update');
        });

        Route::prefix('/riwayat')->name('-riwayat')->group(function () {
            Route::get('/', [PembayaranController::class, 'riwayat'])->name('-transaksi');
            Route::get('/cetak/{id?}', [PembayaranController::class, 'cetak'])->name('-cetak');
        });
    });
});

Route::view('/example', 'example.example')->name('example');
Route::prefix('rekam-medis')->group(function () {
    Route::controller(EntryKunjunganController::class)
        ->prefix('/entry-kunjungan')
        ->name('entry-kunjungan.')
        ->group(function () {
            Route::get('/', 'showEntryKunjungan')->name('index');
            Route::get('/create', 'createEntryKunjungan')->name('create');
            Route::post('/store', 'store')->name('store');
            Route::get('/{id}', 'details')->name('detail');
        });
    Route::controller(RiwayatKunjunganController::class)
        ->prefix('/riwayat-kunjungan')
        ->name('riwayat-kunjungan.')
        ->group(function () {
            Route::get('/', 'showRiwayatKunjungan')->name('index');
            Route::get('/detail', 'showDetailRiwayatKunjungan')->name('detail');
        });
    Route::controller(RiwayatMedisController::class)
        ->prefix('/riwayat-medis')
        ->name('riwayat-medis.')
        ->group(function () {
            Route::get('/', 'showRiwayatMedis')->name('index');
        });
});

app/Http/Controllers/Pharmacy/PharmacyController.php
<?php

namespace App\Http\Controllers\Pharmacy;

use App\Exports\DrugsExport;
use App\Http\Controllers\Controller;
use App\Http\Controllers\Pembayaran\PembayaranController;
use App\Models\DetailKunjungan;
use App\Models\Drugs;
use App\Models\PrescriptionDetails;
use App\Models\Prescriptions;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use Maatwebsite\Excel\Facades\Excel;

class PharmacyController extends Controller
{

    //------------------------------------------ view section ---------------------------------------------------
    public function listMedicine()
    {
        $drugs =  Drugs::all();
        return view('pharmacy.stok_obat', ['drugs' => $drugs]);
    }

    public function detailMedicine($id)
    {
        $drug = Drugs::where('id', $id)->first();
        return view('pharmacy.detail_obat', ['drug' => $drug]);
    }

    public function getPrescriptionView($id)
    {
        $visitDetail = DetailKunjungan::where('id', $id)->first();
        $prescriptionDetails = $this->getPrescriptionDetail($visitDetail->apotek_id, $visitDetail->id);
        $prescription = $this->getPrescription($id);

        $patient = $visitDetail->kunjungan->pasien;
        $doctor = $visitDetail->user;

        return view('pharmacy.apotek', [
            'visitDetail' => $visitDetail,
            'prescriptionDetails' => $prescriptionDetails,
            'patient' => $patient,
            'doctor' => $doctor,
            'prescription' => $prescription,
            'totalPrice' =>  $this->getTotalBill($prescription->id),
        ]);
    }

    public function getPrescriptionDetailView($visitId, $id)
    {
        $drugs = Drugs::where('stock', '!=', 0)->get();
        return view('pharmacy.detail_apotek', [
            'prescriptionDetails' => $this->getPrescriptionDetail($id, null),
            'drugs' => $drugs,
            'prescriptionId' => $id,
            'visitId' => $visitId
        ]);
    }

    public function downloadDrugExcel()
    {
        $drugs = Drugs::all();
        return Excel::download(new DrugsExport($drugs), 'obat.xlsx');
    }

    //------------------------------------------ destroy section ---------------------------------------------------
    public function destroyPrescriptionDetail($id)
    {
        Prescriptions::destroy($id);
    }

    public function destroyDrug($id)
    {
        Drugs::destroy($id);
        return back();
    }

    public function destroyDrugInPrescription(Request $request, $id)
    {
        $this->operateDrugStock($request->drugId, '+', $request->quantity);
        PrescriptionDetails::destroy($id);
        return back();
    }

    //------------------------------------------ create section ---------------------------------------------------
    public function createDrug(Request $request)
    {
        Drugs::create([
            'name' => $request->name,
            'price' => $request->price,
            'name_code' => Str::uuid(),
            'how_to_use' =>  $request->guide,
            'side_effect' =>  $request->sideEffect,
            'stock' => $request->stock
        ]);

        PembayaranController::updatePengeluaran($request->price * $request->stock);

        return back();
    }

    public function createDrugInPrescription(Request $request)
    {
        $quantity = $this->getAvailableDrugs($request->quantity, $request->medicineId);
        PrescriptionDetails::create([
            'prescription_id' => $request->prescriptionId,
            'drug_id' => $request->medicineId,
            'quantity' => $quantity,
        ]);
        return back();
    }

    //------------------------------------------ update section ---------------------------------------------------
    public function updateDrug(Request $request, $id)
    {
        Drugs::where('id', $id)->update([
            'name' => $request->name,
            'price' => $request->price,
            'how_to_use' =>  $request->guide,
            'side_effect' =>  $request->sideEffect,
        ]);
        return back();
    }

    public function updateDrugStock(Request $request, $id)
    {
        if ($request->addSubstractStock == '+') {
            $this->operateDrugStock($id, '+', $request->stock);
        } else {
            $this->operateDrugStock($id, '-', $request->stock);
        }
        return back();
    }


    public function updateDrugInPrescription(Request $request)
    {
        $isChangeLarger = $request->currentQuantity < $request->quantity;
        $isChangeNotSame = $request->currentQuantity != $request->quantity;
        $value = $this->takeTheDifferentValue($request->quantity, $request->currentQuantity);

        if ($isChangeNotSame) {
            $this->operateDrugStock($request->drugId, $isChangeLarger ? '-' : '+', $value);
            PrescriptionDetails::where('id', $request->prescriptionDetailId)->update([
                'quantity' => $request->quantity,
            ]);
        }
        return back();
    }

    public function checkoutPrescription($id, $visitId)
    {
        $this->processInTransaction($this->getTotalBill($id), $visitId);
        Prescriptions::find($id)->update([
            'is_taken' => 1
        ]);
        return back();
    }

    //------------------------------------------ utils section ---------------------------------------------------

    private function getPrescriptionDetail($prescriptionId, $visitDetailId)
    {
        $prescription = $prescriptionId ?
            Prescriptions::where('id', $prescriptionId)->first() :
            $this->initiatePrescription($visitDetailId);
        return $prescription->prescriptionDetail();
    }

    private function initiatePrescription($visitId)
    {
        $prescription = Prescriptions::create([
            'invoice_code' => Str::uuid()
        ]);
        $this->updateVisitPrescriptionId($visitId, $prescription->id);
        return $prescription;
    }

    private function updateVisitPrescriptionId($visitId, $prescriptionId)
    {
        DetailKunjungan::where('id', $visitId)->update([
            'apotek_id' => $prescriptionId
        ]);
    }

    private function getPrescription($id)
    {
        $prescriptionId = DetailKunjungan::where('id', $id)->first()->apotek_id;
        return Prescriptions::where('id', $prescriptionId)->first();
    }

    private function getAvailableDrugs($qtyRequest, $id)
    {
        $stock = Drugs::where('id', $id)->first()->stock;
        $isEnough = $stock > $qtyRequest;

        Drugs::where('id', $id)->update([
            'stock' => $isEnough ? ($stock - $qtyRequest) : 0
        ]);

        return $isEnough ? $qtyRequest : $stock;
    }

    private function operateDrugStock($id, $operation, $value)
    {
        $currentValue = Drugs::where('id', $id)->first()->stock;
        $currentPrice = Drugs::where('id', $id)->first()->price;

        Drugs::where('id', $id)->update([
            'stock' => ($operation == '+') ? $currentValue + $value : $currentValue - $value,
        ]);

        if ($operation == '+') {
            PembayaranController::updatePengeluaran($currentPrice * $value);
        }
    }

    private function takeTheDifferentValue($value1, $value2)
    {
        $value = $value1 - $value2;
        return ($value < 0) ? (-1 * $value) : $value;
    }

    private function getTotalBill($id)
    {
        $prescriptionDetails = Prescriptions::where('id', $id)->first()->prescriptionDetail();
        $bill = 0;
        foreach ($prescriptionDetails as $prescriptionDetail) {
            $bill += $prescriptionDetail->drug()->price * $prescriptionDetail->quantity;
        }
        return $bill;
    }

    private function processInTransaction($totalBill, $visitId)
    {
        $process = DetailKunjungan::find($visitId);

        if ($process->pembayaran == null) {

            $process->pembayaran = 0 + $totalBill;
        } else {
            $process->pembayaran = $process->pembayaran + $totalBill;
        }

        $process->save();
    }

    public function listMedicineAPI()
    {
        $drugs =  Drugs::all();
        // return view('pharmacy.stok_obat', ['drugs' => $drugs]);
        return response()->json($drugs);
    }
}

resources/views/pharmacy/stok_obat.blade.php
@extends('templates.master')
@section('title', 'Apotek / Stok Obat')
@section('page-name', 'Apotek')
@push('styles')
    <link rel="stylesheet" href="{{ asset('assets/extensions/simple-datatables/style.css') }}">
    <link rel="stylesheet" href="{{ asset('assets/scss/pages/simple-datatables.scss') }}">
@endpush
@section('content')
    <div class="card">
        <div class="card-header d-flex justify-content-between">
            <h3 class="card-title">Stok Obat</h3>
            <div class="">
                <a class="btn btn-info" href="{{ route('pharmacy.downloadDrugExcel') }}"><i
                        class="bi bi-file-earmark-arrow-down"></i>
                    download excel</a>
                <button class="btn btn-warning" data-bs-toggle="modal" data-bs-target="#openModal" data-modalLevel="add"><i
                        class="bi bi-plus-circle-fill"></i> Add New Item</button>
            </div>
        </div>
        <div class="card-body">
            <div class="">
            </div>
            <div class="">
                <div class="table-responsive rounded border">
                    <table class="table table-xs" id="resep">
                        <thead class="">
                            <tr class="">
                                <th class="fw-bold px-4">Medicine Name</th>
                                <th class="fw-bold px-4">Medicine ID</th>
                                <th class="fw-bold px-4 text-center">Stock</th>
                                <th class="fw-bold px-4 text-center">Price</th>
                                <th class="fw-bold px-4 text-center">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ($drugs as $drug)
                                <tr class="">
                                    <td class="px-4"> {{ $drug->name }}</td>
                                    <td class="px-4">{{ $drug->name_code }}</td>
                                    <td class="px-4 text-center">{{ $drug->stock }}</td>
                                    <td class="px-4 text-center">Rp. {{ $drug->price }}</td>
                                    <td class="px-4 text-center">
                                        <div class="btn-group" role="group">
                                            <button
                                                class="m-1 rounded bg-primary p-1 btn px-2 text-center fw-bolder text-white"
                                                data-bs-toggle="modal" data-bs-target="#update{{ $drug->id }}"
                                                data-modalLevel="add">
                                                <i class="bi bi-pencil"></i>
                                            </button>
                                            <form action="{{ route('pharmacy.destroyMedicine', $drug->id) }}"
                                                method="post">
                                                @csrf
                                                <button type="submit"
                                                    class="m-1 rounded bg-danger p-1 btn px-2 text-center fw-bolder text-white">
                                                    <i class="bi bi-trash"></i>
                                                </button>
                                            </form>
                                            <a href="{{ route('pharmacy.detailMedicine', $drug->id) }}"
                                                class="m-1 rounded bg-success p-1 btn px-2 text-center fw-bolder text-white">
                                                <i class="bi bi-eye"></i>
                                            </a>
                                        </div>

                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>

        </div>
    </div>
    {{-- Modal --}}
    <div class="modal modal-borderless fade" id="openModal" tabindex="-1" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h1 class="modal-title fs-5" id="exampleModalLabel">Add New Medicine Item</h1>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    {{-- Form --}}
                    <form class="form" id="medicine-form" method="POST" action="{{ route('pharmacy.createMedicine') }}">
                        @csrf
                        <div class="row">
                            <div class="col-md-6 col-12">
                                <div class="form-group">
                                    <label for="medicine-name-column">Medicine Name</label>
                                    <input type="text" id="medicine-name-column" class="form-control" value=''
                                        placeholder="Medicine Name" name="name" required>
                                    <label for="stock-column">Stock</label>
                                    <input type="number" min="0" id="stock-column" class="form-control"
                                        value='' placeholder="Stock" name="stock" required>
                                    <label for="price-column">Price</label>
                                    <div class="input-group">
                                        <span class="input-group-text" id="basic-addon1">Rp</span>
                                        <input type="text" id="price-column" class="form-control" value=''
                                            name="price" placeholder="Price" required>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-6 col-12">
                                <div class="form-group">
                                    <label for="guide-column">How to use</label>
                                    <textarea rows="4" cols="50" id="guide-column" class="form-control" value=''
                                        placeholder="How to use" name="guide" required></textarea>
                                    <label for="side-effect-floating">Side Effect</label>
                                    <textarea rows="4" cols="50" id="side-effect-floating" class="form-control" value=''
                                        name="sideEffect" placeholder="Side Effect" required></textarea>
                                </div>
                            </div>
                        </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-light-secondary me-1 mb-1" onclick="resetForm()">Reset</button>
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="submit" class="btn btn-primary">Save changes</button>
                </div>
                </form>
            </div>
        </div>
    </div>

    @foreach ($drugs as $drug)
        <div class="modal modal-borderless fade" id="update{{ $drug->id }}" tabindex="-1" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered">
                <div class="modal-content">
                    <div class="modal-header">
                        <h1 class="modal-title fs-5" id="exampleModalLabel">Update Medicine Item</h1>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        {{-- Form --}}
                        <form class="form" id="medicine-form" method="POST"
                            action="{{ route('pharmacy.updateMedicine', $drug->id) }}">
                            @csrf
                            <div class="row">
                                <div class="col-md-6 col-12">
                                    <div class="form-group">
                                        <label for="medicine-name-column">Medicine Name</label>
                                        <input type="text" id="medicine-name-column" class="form-control"
                                            value='{{ $drug->name }}' placeholder="Medicine Name" name="name"
                                            required>
                                        <label for="price-column">Price</label>
                                        <div class="input-group">
                                            <span class="input-group-text" id="basic-addon1">Rp</span>
                                            <input type="text" id="price-column" class="form-control"
                                                value='{{ $drug->price }}' name="price" placeholder="Price" required>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-6 col-12">
                                    <div class="form-group">
                                        <label for="guide-column">How to use</label>
                                        <textarea rows="4" cols="50" id="guide-column" class="form-control" placeholder="How to use"
                                            name="guide" required>{{ $drug->how_to_use }}</textarea>
                                        <label for="side-effect-floating">Side Effect</label>
                                        <textarea rows="4" cols="50" id="side-effect-floating" class="form-control" value='{{ $drug->effect }}'
                                            name="sideEffect" placeholder="Side Effect" required>{{ $drug->side_effect }}</textarea>
                                    </div>
                                </div>
                            </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-light-secondary me-1 mb-1"
                            onclick="resetForm()">Reset</button>
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Save changes</button>
                    </div>
                    </form>
                </div>
            </div>
        </div>
    @endforeach

@endsection
@push('scripts')
    <script src="{{ asset('assets/extensions/simple-datatables/umd/simple-datatables.js') }}"></script>
    <script>
        let dataTable = new simpleDatatables.DataTable(
            document.getElementById("resep")
        )
    </script>
    <script>
        document.addEventListener("DOMContentLoaded", function() {
            const openModal = document.getElementById("openModal");
            const modalTitleElement = document.getElementById("exampleModalLabel");

            openModal.addEventListener("show.bs.modal", function(event) {
                const modalTriggerButton = event.relatedTarget;
                const modalLevel = modalTriggerButton.getAttribute("data-modalLevel");
                // console.log("modalLevel:", modalLevel);
                const modalTitle = modalLevel === 'add' ? 'Add New Medicine Item' : 'Update Medicine Item';
                modalTitleElement.innerText = modalTitle;

            });
        });

        function resetForm() {
            document.getElementById("medicine-form").reset();
        }
    </script>
@endpush